Index: src/io/source.c
===================================================================
--- src/io/source.c	(revision 79822038bcad765c48f6004c428d65dd3c483f2e)
+++ src/io/source.c	(revision 4865e4b220200bd82eac01c42a57c3386f05ed0f)
@@ -22,4 +22,5 @@
 #include "aubio_priv.h"
 #include "fvec.h"
+#include "fmat.h"
 #include "io/source.h"
 #ifdef __APPLE__
@@ -60,4 +61,14 @@
 }
 
+void aubio_source_do_multi(aubio_source_t * s, fmat_t * data, uint_t * read) {
+#ifdef __APPLE__
+  aubio_source_apple_audio_do_multi((aubio_source_apple_audio_t *)s->source, data, read);
+#else /* __APPLE__ */
+#if HAVE_SNDFILE
+  aubio_source_sndfile_do_multi((aubio_source_sndfile_t *)s->source, data, read);
+#endif /* HAVE_SNDFILE */
+#endif /* __APPLE__ */
+}
+
 void del_aubio_source(aubio_source_t * s) {
   if (!s) return;
@@ -82,4 +93,14 @@
 }
 
+uint_t aubio_source_get_channels(aubio_source_t * s) {
+#ifdef __APPLE__
+  return aubio_source_apple_audio_get_channels((aubio_source_apple_audio_t *)s->source);
+#else /* __APPLE__ */
+#if HAVE_SNDFILE
+  return aubio_source_sndfile_get_channels((aubio_source_sndfile_t *)s->source);
+#endif /* HAVE_SNDFILE */
+#endif /* __APPLE__ */
+}
+
 uint_t aubio_source_seek (aubio_source_t * s, uint_t seek ) {
 #ifdef __APPLE__
Index: src/io/source.h
===================================================================
--- src/io/source.h	(revision 79822038bcad765c48f6004c428d65dd3c483f2e)
+++ src/io/source.h	(revision 4865e4b220200bd82eac01c42a57c3386f05ed0f)
@@ -70,4 +70,18 @@
 /**
 
+  read polyphonic vector of length hop_size from source object
+
+  \param s source object, created with ::new_aubio_source
+  \param read_to ::fmat_t of data to read to
+  \param read upon returns, equals to number of frames actually read
+
+  Upon returns, `read` contains the number of frames actually read from the
+  source. `hop_size` if enough frames could be read, less otherwise.
+
+*/
+void aubio_source_do_multi(aubio_source_t * s, fmat_t * read_to, uint_t * read);
+
+/**
+
   get samplerate of source object
 
@@ -77,4 +91,14 @@
 */
 uint_t aubio_source_get_samplerate(aubio_source_t * s);
+
+/**
+
+  get channels of source object
+
+  \param s source object, created with ::new_aubio_source
+  \return channels
+
+*/
+uint_t aubio_source_get_channels (aubio_source_t * s);
 
 /**
Index: src/io/source_apple_audio.c
===================================================================
--- src/io/source_apple_audio.c	(revision 79822038bcad765c48f6004c428d65dd3c483f2e)
+++ src/io/source_apple_audio.c	(revision 4865e4b220200bd82eac01c42a57c3386f05ed0f)
@@ -23,4 +23,5 @@
 #include "aubio_priv.h"
 #include "fvec.h"
+#include "fmat.h"
 #include "io/source_apple_audio.h"
 
@@ -57,5 +58,4 @@
   s->path = path;
   s->block_size = block_size;
-  s->channels = 1;
 
   OSStatus err = noErr;
@@ -83,4 +83,5 @@
   s->samplerate = samplerate;
   s->source_samplerate = fileFormat.mSampleRate;
+  s->channels = fileFormat.mChannelsPerFrame;
 
   AudioStreamBasicDescription clientFormat;
@@ -100,7 +101,7 @@
   err = ExtAudioFileSetProperty(s->audioFile, kExtAudioFileProperty_ClientDataFormat,
       propSize, &clientFormat);
-  if (err) { AUBIO_ERROR("error in ExtAudioFileSetProperty, %d\n", (int)err); goto beach;}
-
-#if 0
+  if (err) {
+      AUBIO_ERROR("error in ExtAudioFileSetProperty, %d\n", (int)err);
+#if 1
   // print client and format descriptions
   AUBIO_DBG("Opened %s\n", s->path);
@@ -119,4 +120,6 @@
   AUBIO_DBG("file/client Format.mReserved         : %6d / %d\n",    (int)fileFormat.mReserved        , (int)clientFormat.mReserved);
 #endif
+      goto beach;
+  }
 
   // compute the size of the segments needed to read the input file
@@ -129,5 +132,5 @@
     AUBIO_WRN("up-sampling %s from %0.2fHz to %0.2fHz\n", s->path, fileFormat.mSampleRate, clientFormat.mSampleRate);
   } else {
-    assert (segmentSize == samples );
+    assert ( segmentSize == samples );
     //AUBIO_DBG("not resampling, segmentSize %d, block_size %d\n", segmentSize, s->block_size);
   }
@@ -166,4 +169,33 @@
   }
 
+  *read = (uint_t)loadedPackets;
+  return;
+beach:
+  *read = 0;
+  return;
+}
+
+void aubio_source_apple_audio_do_multi(aubio_source_apple_audio_t *s, fmat_t * read_to, uint_t * read) {
+  UInt32 c, v, loadedPackets = s->block_size;
+  OSStatus err = ExtAudioFileRead(s->audioFile, &loadedPackets, &s->bufferList);
+  if (err) { AUBIO_ERROR("source_apple_audio: error in ExtAudioFileRead, %d\n", (int)err); goto beach;}
+
+  short *data = (short*)s->bufferList.mBuffers[0].mData;
+
+  smpl_t **buf = read_to->data;
+
+  for (v = 0; v < loadedPackets; v++) {
+    for (c = 0; c < s->channels; c++) {
+      buf[c][v] = SHORT_TO_FLOAT(data[ v * s->channels + c]);
+    }
+  }
+  // short read, fill with zeros
+  if (loadedPackets < s->block_size) {
+    for (v = loadedPackets; v < s->block_size; v++) {
+      for (c = 0; c < s->channels; c++) {
+        buf[c][v] = 0.;
+      }
+    }
+  }
   *read = (uint_t)loadedPackets;
   return;
@@ -185,6 +217,6 @@
 
 uint_t aubio_source_apple_audio_seek (aubio_source_apple_audio_t * s, uint_t pos) {
-  Float64 ratio = (Float64)(s->source_samplerate) / (Float64)(s->samplerate);
-  OSStatus err = ExtAudioFileSeek(s->audioFile, pos);
+  SInt64 resampled_pos = (SInt64)ROUND( pos * s->source_samplerate * 1. / s->samplerate );
+  OSStatus err = ExtAudioFileSeek(s->audioFile, resampled_pos);
   if (err) AUBIO_ERROR("source_apple_audio: error in ExtAudioFileSeek (%d)\n", (int)err);
   return err;
@@ -195,3 +227,7 @@
 }
 
+uint_t aubio_source_apple_audio_get_channels(aubio_source_apple_audio_t * s) {
+  return s->channels;
+}
+
 #endif /* __APPLE__ */
Index: src/io/source_apple_audio.h
===================================================================
--- src/io/source_apple_audio.h	(revision 79822038bcad765c48f6004c428d65dd3c483f2e)
+++ src/io/source_apple_audio.h	(revision 4865e4b220200bd82eac01c42a57c3386f05ed0f)
@@ -76,4 +76,18 @@
 /**
 
+  read polyphonic vector of length hop_size from source object
+
+  \param s source object, created with ::new_aubio_source_apple_audio
+  \param read_to ::fmat_t of data to read to
+  \param read upon returns, equals to number of frames actually read
+
+  Upon returns, `read` contains the number of frames actually read from the
+  source. `hop_size` if enough frames could be read, less otherwise.
+
+*/
+void aubio_source_apple_audio_do_multi(aubio_source_apple_audio_t * s, fmat_t * read_to, uint_t * read);
+
+/**
+
   get samplerate of source object
 
@@ -83,4 +97,14 @@
 */
 uint_t aubio_source_apple_audio_get_samplerate(aubio_source_apple_audio_t * s);
+
+/**
+
+  get channels of source object
+
+  \param s source object, created with ::new_aubio_source_apple_audio
+  \return number of channels
+
+*/
+uint_t aubio_source_apple_audio_get_channels(aubio_source_apple_audio_t * s);
 
 /**
Index: src/io/source_sndfile.c
===================================================================
--- src/io/source_sndfile.c	(revision 79822038bcad765c48f6004c428d65dd3c483f2e)
+++ src/io/source_sndfile.c	(revision 4865e4b220200bd82eac01c42a57c3386f05ed0f)
@@ -159,5 +159,5 @@
     data[j] = 0;
     for (i = 0; i < input_channels; i++) {
-      data[j] += (smpl_t)s->scratch_data[input_channels*j+i];
+      data[j] += s->scratch_data[input_channels*j+i];
     }
     data[j] /= (smpl_t)input_channels;
@@ -173,6 +173,44 @@
 }
 
+void aubio_source_sndfile_do_multi(aubio_source_sndfile_t * s, fmat_t * read_data, uint_t * read){
+  uint_t i,j, input_channels = s->input_channels;
+  /* do actual reading */
+  sf_count_t read_samples = sf_read_float (s->handle, s->scratch_data, s->scratch_size);
+
+  smpl_t **data;
+
+#ifdef HAVE_SAMPLERATE
+  if (s->ratio != 1) {
+    AUBIO_ERR("source_sndfile: no multi channel resampling yet");
+    return;
+    data = s->input_data->data;
+  } else
+#endif /* HAVE_SAMPLERATE */
+  {
+    data = read_data->data;
+  }
+
+  /* de-interleaving data */
+  for (j = 0; j < read_samples / input_channels; j++) {
+    for (i = 0; i < input_channels; i++) {
+      data[i][j] = (smpl_t)s->scratch_data[input_channels*j+i];
+    }
+  }
+
+#ifdef HAVE_SAMPLERATE
+  if (s->resampler) {
+    aubio_resampler_do(s->resampler, s->input_data, read_data);
+  }
+#endif /* HAVE_SAMPLERATE */
+
+  *read = (int)FLOOR(s->ratio * read_samples / input_channels + .5);
+}
+
 uint_t aubio_source_sndfile_get_samplerate(aubio_source_sndfile_t * s) {
   return s->samplerate;
+}
+
+uint_t aubio_source_sndfile_get_channels(aubio_source_sndfile_t * s) {
+  return s->input_channels;
 }
 
Index: src/io/source_sndfile.h
===================================================================
--- src/io/source_sndfile.h	(revision 79822038bcad765c48f6004c428d65dd3c483f2e)
+++ src/io/source_sndfile.h	(revision 4865e4b220200bd82eac01c42a57c3386f05ed0f)
@@ -85,4 +85,14 @@
 /**
 
+  get number of channels of source object
+
+  \param s source object, created with ::new_aubio_source_sndfile
+  \return number of channels
+
+*/
+uint_t aubio_source_sndfile_get_channels (aubio_source_sndfile_t * s);
+
+/**
+
   seek source object
 