Index: examples/utils.c
===================================================================
--- examples/utils.c	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ examples/utils.c	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -69,5 +69,5 @@
 fvec_t *onset2;
 smpl_t isonset = 0;
-aubio_pickpeak_t *parms;
+aubio_peakpicker_t *parms;
 
 
Index: examples/utils.h
===================================================================
--- examples/utils.h	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ examples/utils.h	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -102,5 +102,5 @@
 extern fvec_t *onset2;
 extern smpl_t isonset;
-extern aubio_pickpeak_t *parms;
+extern aubio_peakpicker_t *parms;
 
 
Index: src/onset/onset.c
===================================================================
--- src/onset/onset.c	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ src/onset/onset.c	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -31,5 +31,5 @@
   aubio_pvoc_t * pv;            /**< phase vocoder */
   aubio_onsetdetection_t * od;  /**< onset detection */ 
-  aubio_pickpeak_t * pp;        /**< peak picker */
+  aubio_peakpicker_t * pp;      /**< peak picker */
   cvec_t * fftgrain;            /**< phase vocoder output */
   fvec_t * of;                  /**< onset detection function */
Index: src/onset/peakpick.c
===================================================================
--- src/onset/peakpick.c	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ src/onset/peakpick.c	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -30,5 +30,5 @@
  *	time->           ^now
  */
-struct _aubio_pickpeak_t {
+struct _aubio_peakpicker_t {
 	/** thresh: offset threshold [0.033 or 0.01] */
 	smpl_t threshold; 	
@@ -68,5 +68,5 @@
  * is slightly more permissive than the offline one, and yelds to an increase
  * of false positives. best  */
-smpl_t aubio_peakpicker_do(aubio_pickpeak_t * p, fvec_t * onset) {
+smpl_t aubio_peakpicker_do(aubio_peakpicker_t * p, fvec_t * onset) {
 	fvec_t * onset_keep = (fvec_t *)p->onset_keep;
 	fvec_t * onset_proc = (fvec_t *)p->onset_proc;
@@ -121,5 +121,5 @@
  * after smoothing
  */
-smpl_t aubio_peakpicker_get_thresholded_input(aubio_pickpeak_t * p) 
+smpl_t aubio_peakpicker_get_thresholded_input(aubio_peakpicker_t * p) 
 {
 	return p->onset_peek->data[0][1];
@@ -127,24 +127,24 @@
 
 /** function added by Miguel Ramirez to return the onset detection amplitude in peakval */
-void aubio_peakpicker_set_threshold(aubio_pickpeak_t * p, smpl_t threshold) {
+void aubio_peakpicker_set_threshold(aubio_peakpicker_t * p, smpl_t threshold) {
 	p->threshold = threshold;
 	return;
 }
 
-smpl_t aubio_peakpicker_get_threshold(aubio_pickpeak_t * p) {
+smpl_t aubio_peakpicker_get_threshold(aubio_peakpicker_t * p) {
 	return p->threshold;
 }
 
-void aubio_peakpicker_set_thresholdfn(aubio_pickpeak_t * p, aubio_thresholdfn_t thresholdfn) {
+void aubio_peakpicker_set_thresholdfn(aubio_peakpicker_t * p, aubio_thresholdfn_t thresholdfn) {
 	p->thresholdfn = thresholdfn;
 	return;
 }
 
-aubio_thresholdfn_t aubio_peakpicker_get_thresholdfn(aubio_pickpeak_t * p) {
+aubio_thresholdfn_t aubio_peakpicker_get_thresholdfn(aubio_peakpicker_t * p) {
 	return (aubio_thresholdfn_t) (p->thresholdfn);
 }
 
-aubio_pickpeak_t * new_aubio_peakpicker(smpl_t threshold) {
-	aubio_pickpeak_t * t = AUBIO_NEW(aubio_pickpeak_t);
+aubio_peakpicker_t * new_aubio_peakpicker(smpl_t threshold) {
+	aubio_peakpicker_t * t = AUBIO_NEW(aubio_peakpicker_t);
 	t->threshold = 0.1; /* 0.0668; 0.33; 0.082; 0.033; */
 	if (threshold > 0. && threshold < 10.)
@@ -167,5 +167,5 @@
 }
 
-void del_aubio_peakpicker(aubio_pickpeak_t * p) {
+void del_aubio_peakpicker(aubio_peakpicker_t * p) {
 	del_aubio_biquad(p->biquad);
 	del_fvec(p->onset_keep);
Index: src/onset/peakpick.h
===================================================================
--- src/onset/peakpick.h	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ src/onset/peakpick.h	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -36,23 +36,23 @@
 typedef uint_t (*aubio_pickerfn_t)(fvec_t *input, uint_t pos);
 /** peak-picker structure */
-typedef struct _aubio_pickpeak_t aubio_pickpeak_t;
+typedef struct _aubio_peakpicker_t aubio_peakpicker_t;
 
 /** peak-picker creation function */
-aubio_pickpeak_t * new_aubio_peakpicker(smpl_t threshold);
+aubio_peakpicker_t * new_aubio_peakpicker(smpl_t threshold);
 /** real time peak picking function */
-smpl_t aubio_peakpicker_do(aubio_pickpeak_t * p, fvec_t * DF);
+smpl_t aubio_peakpicker_do(aubio_peakpicker_t * p, fvec_t * DF);
 /** get current peak value */
-smpl_t aubio_peakpicker_get_thresholded_input(aubio_pickpeak_t * p);
+smpl_t aubio_peakpicker_get_thresholded_input(aubio_peakpicker_t * p);
 /** destroy peak picker structure */
-void del_aubio_peakpicker(aubio_pickpeak_t * p);
+void del_aubio_peakpicker(aubio_peakpicker_t * p);
 
 /** set peak picking threshold */
-void aubio_peakpicker_set_threshold(aubio_pickpeak_t * p, smpl_t threshold);
+void aubio_peakpicker_set_threshold(aubio_peakpicker_t * p, smpl_t threshold);
 /** get peak picking threshold */
-smpl_t aubio_peakpicker_get_threshold(aubio_pickpeak_t * p);
+smpl_t aubio_peakpicker_get_threshold(aubio_peakpicker_t * p);
 /** set peak picker thresholding function */
-void aubio_peakpicker_set_thresholdfn(aubio_pickpeak_t * p, aubio_thresholdfn_t thresholdfn);
+void aubio_peakpicker_set_thresholdfn(aubio_peakpicker_t * p, aubio_thresholdfn_t thresholdfn);
 /** get peak picker thresholding function */
-aubio_thresholdfn_t aubio_peakpicker_get_thresholdfn(aubio_pickpeak_t * p);
+aubio_thresholdfn_t aubio_peakpicker_get_thresholdfn(aubio_peakpicker_t * p);
 
 #ifdef __cplusplus
Index: src/tempo/tempo.c
===================================================================
--- src/tempo/tempo.c	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ src/tempo/tempo.c	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -32,5 +32,5 @@
   aubio_onsetdetection_t * od;   /** onset detection */
   aubio_pvoc_t * pv;             /** phase vocoder */
-  aubio_pickpeak_t * pp;         /** peak picker */
+  aubio_peakpicker_t * pp;       /** peak picker */
   aubio_beattracking_t * bt;     /** beat tracking */
   cvec_t * fftgrain;             /** spectral frame */
Index: swig/aubio.i
===================================================================
--- swig/aubio.i	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ swig/aubio.i	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -163,5 +163,5 @@
 /* filterbank */
 aubio_filterbank_t * new_aubio_filterbank(uint_t win_s, uint_t channels);
-void aubio_filterbank_set_mel_coeffs(aubio_filterbank_t *fb, uint_t samplerate, fvec_t *freqs);
+void aubio_filterbank_set_triangle_bands (aubio_filterbank_t *fb, uint_t samplerate, fvec_t *freqs);
 void aubio_filterbank_set_mel_coeffs_slaney(aubio_filterbank_t *fb, uint_t samplerate);
 void del_aubio_filterbank(aubio_filterbank_t * fb);
@@ -270,10 +270,10 @@
 
 /* peakpicker */
-aubio_pickpeak_t * new_aubio_peakpicker(smpl_t threshold);
-smpl_t aubio_peakpicker_do(aubio_pickpeak_t * p, fvec_t * df);
-smpl_t aubio_peakpicker_get_thresholded_input(aubio_pickpeak_t* p);
-void del_aubio_peakpicker(aubio_pickpeak_t * p);
-void aubio_peakpicker_set_threshold(aubio_pickpeak_t * p, smpl_t threshold);
-smpl_t aubio_peakpicker_get_threshold(aubio_pickpeak_t * p);
+aubio_peakpicker_t * new_aubio_peakpicker(smpl_t threshold);
+smpl_t aubio_peakpicker_do(aubio_peakpicker_t * p, fvec_t * df);
+smpl_t aubio_peakpicker_get_thresholded_input(aubio_peakpicker_t* p);
+void del_aubio_peakpicker(aubio_peakpicker_t * p);
+void aubio_peakpicker_set_threshold(aubio_peakpicker_t * p, smpl_t threshold);
+smpl_t aubio_peakpicker_get_threshold(aubio_peakpicker_t * p);
 
 /* transient/steady state separation */
Index: tests/src/test-peakpick.c
===================================================================
--- tests/src/test-peakpick.c	(revision cfa0f12a613d3425efeeddc68e5dbf1bb1181f0c)
+++ tests/src/test-peakpick.c	(revision 8766cb6ec331b4b5b572f825727a0c9fd9f76233)
@@ -6,5 +6,5 @@
         uint_t channels   = 1;                          /* number of channel */
         fvec_t * in       = new_fvec (win_s, channels); /* input buffer */
-        aubio_pickpeak_t * o = new_aubio_peakpicker(0.3);
+        aubio_peakpicker_t * o = new_aubio_peakpicker(0.3);
 
         aubio_peakpicker_do(o, in);